package mje;
import mje.MJEData.Vec2;
import mje.MJEData.Vector2;

typedef Vec2 = { x:Float, y:Float }

abstract Vector2(Vec2) {	
	inline public function new(x:Float, y:Float) {
		this = { x: x, y: y };
	}
	
	public var x(get, set):Float;
	public var y(get, set):Float;
	inline public function get_x():Float { return this.x; }
	inline public function set_x(v:Float):Float { return this.x = v; }
	inline public function get_y():Float { return this.y; }
	inline public function set_y(v:Float):Float { return this.y = v; }
	
	public inline function set(x:Float, y:Float):Vector2
	{
		return new Vector2(x, y);		
	}
	
	public inline function length():Float
	{
		return Math.sqrt(this.x * this.x + this.y * this.y);
	}
	
	@:op(A + B)
	public inline function add(vec2:Vector2):Vector2
	{
		return new Vector2(this.x + vec2.x, this.y + vec2.y);
	}
	
	@:op(A * B)
	public inline function smul(scalar:Float):Vector2
	{
		return new Vector2(this.x * scalar, this.y * scalar);
	}
	
	@:op(A * B)
	public inline function dot(vec2:Vector2):Float
	{
		return this.x * vec2.x + this.y * vec2.y;
	}
	
	@:from
	static public inline function fromVec2(vec2:Vec2):Vector2
	{
		return new Vector2(vec2.x, vec2.y);
	}
	
	@:to
	public inline function toVec2()
	{
		return { x: this.x, y: this.y };
	}
}